package grammar;

import java.io.*;

%%

%public
%class Test
%type Void

%{
	void prompt() {
		System.out.println( "1) [happy]" );
		System.out.println( "2) a-z" );
		System.out.println( "3) [happy|sad]" );
		System.out.println( "4) \"happy|sad\"" );
		System.out.println( "5) [\"happy\"|\"sad\"]" );
		System.out.print( "Case?: " ); 
		}
%}
%init{
    yybegin( NORMAL ); prompt();
%init}

newline 	=	\r | \n | \r\n


%state NORMAL, CASE1, CASE2, CASE3, CASE4, CASE5

%%
<NORMAL> {
	1{newline}			{ yybegin( CASE1 ); System.out.print( "[happy]: " ); }
	2{newline}			{ yybegin( CASE2 ); System.out.print( "a-z: " ); }
	3{newline}			{ yybegin( CASE3 ); System.out.print( "[happy|sad]: " ); }
	4{newline}			{ yybegin( CASE4 ); System.out.print( "\"happy|sad\": " ); }
	5{newline}			{ yybegin( CASE4 ); System.out.print( "[\"happy\"|\"sad\"]: " ); }
	}	

<CASE1>[happy]			{ System.out.println( "Match " + yytext() ); }
<CASE2>a-z				{ System.out.println( "Match " + yytext() ); }
<CASE3>[happy|sad]		{ System.out.println( "Match " + yytext() ); }
<CASE4>"happy|sad"		{ System.out.println( "Match " + yytext() ); }
<CASE4>["happy"|"sad"]	{ System.out.println( "Match " + yytext() ); }
{newline}				{ 
						yybegin( NORMAL );
						prompt();
						}
.						{ }

